madwifi update: include upstream fixes for ff handling, disable ff by default (not...
[openwrt.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5         local device="$1"
6         local wds
7         local adhoc sta ap
8         
9         config_get vifs "$device" vifs
10         for vif in $vifs; do
11         
12                 config_get ifname "$vif" ifname
13                 config_set "$vif" ifname "${ifname:-ath}"
14                 
15                 config_get mode "$vif" mode
16                 case "$mode" in
17                         adhoc|ahdemo|sta|ap)
18                                 append $mode "$vif"
19                         ;;
20                         wds)
21                                 config_get addr "$vif" bssid
22                                 config_get ssid "$vif" ssid
23                                 [ -z "$addr" -a -n "$ssid" ] && {
24                                         config_set "$vif" wds 1
25                                         config_set "$vif" mode sta
26                                         mode="sta"
27                                         addr="$ssid"
28                                 }
29                                 ${addr:+append $mode "$vif"}
30                         ;;
31                         *) echo "$device($vif): Invalid mode, ignored."; continue;;
32                 esac
33         done
34
35         case "${adhoc:+1}:${sta:+1}:${ap+1}" in
36                 # valid mode combinations
37                 1::) wds="";;
38                 1::1);;
39                 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
40                 :1:);;
41                 ::1);;
42                 ::);;
43                 *) echo "$device: Invalid mode combination in config"; return 1;;
44         esac
45
46         config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
47 }
48
49
50 disable_atheros() (
51         local device="$1"
52
53         # kill all running hostapd and wpa_supplicant processes that
54         # are running on atheros vifs 
55         for pid in `pidof hostapd wpa_supplicant`; do
56                 grep ath /proc/$pid/cmdline >/dev/null && \
57                         kill $pid
58         done
59         
60         include /lib/network
61         cd /proc/sys/net
62         for dev in *; do
63                 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
64                         ifconfig "$dev" down 
65                         unbridge "$dev"
66                         wlanconfig "$dev" destroy
67                 }
68         done
69         return 0
70 )
71
72 enable_atheros() {
73         config_get channel "$device" channel
74         config_get vifs "$device" vifs
75         
76         disable_atheros "$device"
77         local first=1
78         for vif in $vifs; do
79                 nosbeacon=
80                 config_get ifname "$vif" ifname
81                 config_get enc "$vif" encryption
82                 config_get mode "$vif" mode
83                 
84                 [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
85                 
86                 config_get ifname "$vif" ifname
87                 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
88                 [ $? -ne 0 ] && {
89                         echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
90                         continue
91                 }
92                 config_set "$vif" ifname "$ifname"
93
94                 [ "$first" = 1 ] && {
95                         # only need to change freq band and channel on the first vif
96                         config_get agmode "$device" mode
97                         pureg=0
98                         case "$agmode" in
99                                 *b) agmode=11b;;
100                                 *bg) agmode=11g;;
101                                 *g) agmode=11g; pureg=1;;
102                                 *a) agmode=11a;;
103                                 *) agmode=auto;;
104                         esac
105                         iwconfig "$ifname" channel 0 >/dev/null 2>/dev/null 
106                         ifconfig "$ifname" up
107                         iwpriv "$ifname" mode "$agmode"
108                         iwpriv "$ifname" pureg "$pureg"
109                         iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
110                 }
111         
112                 config_get_bool hidden "$vif" hidden 0
113                 iwpriv "$ifname" hide_ssid "$hidden"
114
115                 config_get_bool ff "$vif" ff 0
116                 iwpriv "$ifname" ff "$ff"
117
118                 config_get wds "$vif" wds
119                 case "$wds" in
120                         1|on|enabled) wds=1;;
121                         *) wds=0;;
122                 esac
123                 iwpriv "$ifname" wds "$wds"
124
125                 wpa=
126                 case "$enc" in
127                         WEP|wep)
128                                 for idx in 1 2 3 4; do
129                                         config_get key "$vif" "key${idx}"
130                                         iwconfig "$ifname" enc "[$idx]" "${key:-off}"
131                                 done
132                                 config_get key "$vif" key
133                                 key="${key:-1}"
134                                 case "$key" in
135                                         [1234]) iwconfig "$ifname" enc "[$key]";;
136                                         *) iwconfig "$ifname" enc "$key";;
137                                 esac
138                         ;;
139                         PSK|psk|PSK2|psk2)
140                                 config_get key "$vif" key
141                         ;;
142                 esac
143
144                 case "$mode" in
145                         wds)
146                                 config_get addr "$vif" bssid
147                                 iwpriv "$ifname" wds_add "$addr"
148                         ;;
149                         adhoc|ahdemo)
150                                 config_get addr "$vif" bssid
151                                 [ -z "$addr" ] || { 
152                                         iwconfig "$ifname" ap "$addr"
153                                 }
154                         ;;
155                 esac
156                 config_get ssid "$vif" ssid
157
158                 [ "$mode" = "sta" ] && {
159                         config_get_bool bgscan "$vif" bgscan 1
160                         iwpriv "$ifname" bgscan "$bgscan"
161                 }
162
163                 config_get_bool antdiv "$device" diversity 1
164                 sysctl -w dev."$device".diversity="$antdiv" >&-
165
166                 config_get antrx "$device" rxantenna
167                 if [ -n "$antrx" ]; then
168                         sysctl -w dev."$device".rxantenna="$antrx" >&-
169                 fi
170
171                 config_get anttx "$device" txantenna
172                 if [ -n "$anttx" ]; then
173                         sysctl -w dev."$device".txantenna="$anttx" >&-
174                 fi
175
176                 config_get distance "$device" distance
177                 if [ -n "$distance" ]; then
178                         athctrl -i "$device" -d "$distance" >&-
179                 fi
180
181                 config_get txpwr "$vif" txpower
182                 if [ -n "$txpwr" ]; then
183                         iwconfig "$ifname" txpower "${txpwr%%.*}"
184                 fi
185
186                 ifconfig "$ifname" up
187                 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
188
189                 local net_cfg bridge
190                 net_cfg="$(find_net_config "$vif")"
191                 [ -z "$net_cfg" ] || {
192                         bridge="$(bridge_interface "$net_cfg")"
193                         config_set "$vif" bridge "$bridge"
194                         start_net "$ifname" "$net_cfg"
195                 }
196                 iwconfig "$ifname" essid "$ssid"
197                 case "$mode" in
198                         ap)
199                                 config_get_bool isolate "$vif" isolate 0
200                                 iwpriv "$ifname" ap_bridge "$((isolate^1))"
201
202                                 if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
203                                         hostapd_setup_vif "$vif" madwifi || {
204                                                 echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
205                                                 # make sure this wifi interface won't accidentally stay open without encryption
206                                                 ifconfig "$ifname" down
207                                                 wlanconfig "$ifname" destroy
208                                                 continue
209                                         }
210                                 fi
211                         ;;
212                         wds|sta)
213                                 case "$enc" in 
214                                         PSK|psk|PSK2|psk2)
215                                                 case "$enc" in
216                                                         PSK|psk)
217                                                                 proto='proto=WPA';;
218                                                         PSK2|psk2)
219                                                                 proto='proto=RSN';;
220                                                 esac
221                                                 cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
222 ctrl_interface=/var/run/wpa_supplicant
223 network={
224         scan_ssid=1
225         ssid="$ssid"
226         key_mgmt=WPA-PSK
227         $proto
228         psk="$key"
229 }
230 EOF
231                                         ;;
232                                         WPA|wpa|WPA2|wpa2)
233                                                 #add wpa_supplicant calls here
234                                         ;;
235                                 esac
236                                 [ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -Bw -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
237                         ;;
238                 esac
239                 first=0
240         done
241 }
242
243
244 detect_atheros() {
245         cd /proc/sys/dev
246         [ -d ath ] || return
247         for dev in $(ls -d wifi* 2>&-); do
248                 config_get type "$dev" type
249                 [ "$type" = atheros ] && return
250                 cat <<EOF
251 config wifi-device  $dev
252         option type     atheros
253         option channel  5
254 #       option diversity 1
255 #       option txantenna 0
256 #       option rxantenna 0
257 #       option distance  2000
258 # disable radio to prevent an open ap after reflashing:
259         option disabled 1
260
261
262 config wifi-iface
263         option device   $dev
264         option network  lan
265         option mode     ap
266         option ssid     OpenWrt
267         option hidden   0
268 #       option txpower  15
269 #       option bgscan   enable
270         option encryption none
271
272 EOF
273         done
274 }